//SQ7615_I2C
//*************************************************************************************
// 	: main.c
// 汾		: V3.2
// 		: 
// ˵	: ΪһSQ7615MasterͲָͬȡSlaveϡ
//			  °1: ָ = 0x09 = 0x1234 ͨѶɹLED1δͨѶͨѶʧLED1
//      	  °2: ָ = 0x0A = 0x55AA ͨѶɹLED2δͨѶͨѶʧLED2
//      	  °3: ָ = 0x00 = 0xFFFF ͨѶɹLED3δͨѶͨѶʧLED3
// 
// ע		: 1. Slave  Master˵ 
//            	 I2C0ΪSlave(ַΪ0x68), 
//			         (P0.5)ΪSDA0
//		             (P0.6)ΪSCL0
// 
//			     I2C1ΪMaster
//		             (P4.6)ΪSDA1
//		             (P4.7)ΪSCL1
// 
//			  2. (P0.5)SDA0----ӵ----(P4.6)SDA1
//				 (P0.6)SCL0----ӵ----(P4.7)SCL1
//	             *SDA,SCLⲿ
// 
//			  3. []	1  BTN1(P3.0)(EINT0)
//							2  BTN2(P3.1)(EINT1)
//						    3  BTN3(P3.2)(EINT2)
//
//				  [LED] LED 1  (P2.0)
//				  [LED] LED 2  (P2.1)
//				  [LED] LED 3  (P2.2)
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "main.h"

/* ----------------------  -------------------------- */
I2C_MasterPacket i2c_master;
I2C_SlavePacket  i2c_slave;

/* -----------------------  --------------------------- */
void main()
{
/* ---------------------- ϵͳʼ ------------------------ */
	PLLCR0_PLLEN  = 1;                     	  //  PLL
	while(PLLCR0_PLLRDY ==0);				  // ȴ PLL 
	CLKCR0_SCKPSC = 1;                        // ϵͳƵʳ2   (48M/2=24MHz) 
    CLKCR0_SCKSRC = 1;                        // ʱԴлPLL
	while(CLKCR0_SCKRDY ==0);				  // ȴ ϵͳʱ 
/* ---------------------- ܽųʼ ------------------------ */
    P2OE  = 0x07;                        	  // 趨P2.0,P2.1,P2.2 ܽΪ
    P3OE  = 0x00;                        	  // 趨P3.0,P3.1,P3.2 ܽΪ
	P3PU |= 0x07;                       	  // 趨P3.0,P3.1,P3.2 
	LED1_out = 1;							  // ʼ趨LED1Ϊ״̬
	LED2_out = 1;							  // ʼ趨LED2Ϊ״̬
	LED3_out = 1;							  // ʼ趨LED3Ϊ״̬
/* ---------------------- EINT ʼ ------------------------ */
	EINT_Init();                        	  // EINT ʼ趨
	EINT_IntEnable();                   	  // EINT ж
/* ---------------------- I2C0 ʼ ------------------------ */
    //I2C, 8λֽ , Ack , ģʽ
    I2C0_Init();							  // I2C0ΪSlave, ַΪ0x68
	I2C0_IntEnable();						  // I2C0ж
 /* ---------------------- I2C1 ʼ ------------------------ */
    I2C1_Init();						      // I2C1Master , I2C1 жϽ 
	i2c_master.adr = SLAVE_ADDR;			  // ͵ĵַΪ0x68
	i2c_master.cmd = 0x09;
	//---------------------------------------------------------------------------------
    while(1){								  
		if(Push_BTN1_Flag){      	  		  // 1_ ֮ⲿжBTN1(EXT0)=1
	        Push_BTN1_Flag = 0;				  // "1_ ֮ⲿж"BTN1(EXT0)һΰ
            i2c_master.cmd = 0x09;	          // İlָ0x09
			i2c_master.len = 2;				  // I2CxȡָL(word2byte)
			
			if(I2C_Master_Read(I2C_1,&i2c_master)==1){
				// I2Cȡɹ
				LED1_out = 0;                 // LED1            
			}
			else{
				// I2Cȡʧ
			    LED1_out = 1; 				  // LED1
			}
		}
		//----------------------------------------------------------------------------
		if(Push_BTN2_Flag){      	  		  // 2_ ֮ⲿжBTN2(EXT1)=1
			Push_BTN2_Flag = 0;				  // "2_ ֮ⲿж"BTN2(EXT1)һΰ
			i2c_master.cmd = 0x0a;      	  // İlָ0x0A
			i2c_master.len = 2;         	  // I2CxȡָL(word2byte)
			if(I2C_Master_Read(I2C_1,&i2c_master)==1){
				// I2Cȡɹ
			    LED2_out = 0;				  // LED2  
			}
			else{
				// I2Cxȡʧ
			    LED2_out = 1;				  // LED2
			}
		}
		//----------------------------------------------------------------------------
		if(Push_BTN3_Flag){      	  		  // 3_ ֮ⲿжBTN3(EXT2)=1
			Push_BTN3_Flag = 0;				  // "3_ ֮ⲿж"BTN3(EXT2)һΰ
			i2c_master.cmd = 0x00;      	  // İlָ0x00
			i2c_master.len = 2;         	  // I2CxȡָL(word2byte)
			if(I2C_Master_Read(I2C_1,&i2c_master)==1){
				// I2Cxȡɹ
			    LED3_out = 0;				  // LED3 
			}
			else{
				// I2Cxȡʧ
			    LED3_out = 1;				  // LED3
			}
		}		
	    //------------------------------------------------------------------------------
    }
}


/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void)
{
	__asm("NOP"); 							  // ָ
}

void __interrupt_n OnlyRetn(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntWDT(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntSWI(void)              // SWIλжϷ
{
	PRSTR7 = 0x5a;
	PRSTR7 = 0xa5;
	PRSTR7 = 0xc3;
	PRSTR7 = 0x3c;	
}
/* -------------------  жϷ ---------------------- */


/* -------------------- SQ7615ж ------------------ */
#pragma section const INT_VECTOR1 0xff40
void * const IntTbl1[] = {											
	OnlyReti,				/* 0xff40 : Reserved		*/									
	OnlyReti,				/* 0xff42 : Reserved		*/									
	OnlyReti,				/* 0xff44 : Reserved		*/									
	OnlyReti,				/* 0xff46 : Reserved		*/								
	OnlyReti,				/* 0xff48 : Reserved		*/									
	OnlyReti,				/* 0xff4a : Reserved		*/									
	OnlyReti,				/* 0xff4c : Reserved		*/									
	OnlyReti,				/* 0xff4e : Reserved		*/									
	OnlyReti,				/* 0xff50 : Reserved		*/									
	OnlyReti,				/* 0xff52 : Reserved		*/									
	OnlyReti,				/* 0xff54 : Reserved		*/									
	OnlyReti,				/* 0xff56 : Reserved		*/									
	OnlyReti,				/* 0xff58 : IntTCA7			*/	//жԴ:TCA7 16λʱ								
	OnlyReti,				/* 0xff5a : IntTCA6			*/	//жԴ:TCA6 16λʱ							
	OnlyReti,				/* 0xff5c : Reserved		*/									
	OnlyReti,				/* 0xff5e : Reserved		*/									
	OnlyReti,				/* 0xff60 : Reserved		*/									
	OnlyReti,				/* 0xff62 : Reserved		*/									
	OnlyReti,				/* 0xff64 : Reserved		*/									
	OnlyReti,				/* 0xff66 : Reserved		*/									
	OnlyReti,				/* 0xff68 : Reserved		*/									
	OnlyReti,				/* 0xff6a : Reserved		*/									
	OnlyReti,				/* 0xff6c : IntTX2			*/	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : IntRX2			*/	//жԴ:UART2 RX2							
	OnlyReti,				/* 0xff70 : Reserved		*/									
	OnlyReti,				/* 0xff72 : Reserved		*/									
	OnlyReti,				/* 0xff74 : Reserved		*/									
	OnlyReti,				/* 0xff76 : IntTCA5			*/	//жԴ:TCA5 16λʱ								
	OnlyReti,				/* 0xff78 : IntTCA4			*/	//жԴ:TCA4 16λʱ								
	OnlyReti,				/* 0xff7a : Reserved		*/									
	OnlyReti,				/* 0xff7c : Reserved		*/									
	OnlyReti,				/* 0xff7e : Reserved		*/									
	OnlyReti,				/* 0xff80 : Reserved		*/									
	OnlyReti,		    	/* 0xff82 : Reserved		*/									
	OnlyReti,	    		/* 0xff84 : Reserved		*/									
	OnlyReti,				/* 0xff86 : Reserved		*/									
	OnlyReti,				/* 0xff88 : Reserved		*/									
	OnlyReti,				/* 0xff8a : Reserved		*/									
	OnlyReti,				/* 0xff8c : IntSIO1			*/	//жԴ:SIO 1								
	IntI2C1,				/* 0xff8e : IntI2C1			*/	//жԴ:I2C 1						
	OnlyReti,				/* 0xff90 : IntTX1			*/	//жԴ:UART1 TX1							
	OnlyReti,				/* 0xff92 : IntRX1			*/	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		*/									
	OnlyReti,				/* 0xff96 : Reserved		*/									
	OnlyReti,				/* 0xff98 : Reserved		*/									
	OnlyReti,				/* 0xff9a : IntTCA3			*/	//жԴ:TCA3 16λʱ							
	OnlyReti,				/* 0xff9c : IntTCA2			*/	//жԴ:TCA2 16λʱ								
	OnlyReti,				/* 0xff9e : Reserved		*/									
	OnlyReti,				/* 0xffa0 : IntMAC			*/	//жԴ:˷								
	OnlyReti,				/* 0xffa2 : IntEXT7			*/	//ⲿж7								
	OnlyReti,				/* 0xffa4 : IntEXT6			*/	//ⲿж6								
	OnlyReti,				/* 0xffa6 : IntEXT5			*/	//ⲿж5								
	OnlyReti,				/* 0xffa8 : IntEXT4			*/	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		*/									
	OnlyReti,				/* 0xffac : Reserved		*/									
	OnlyReti,				/* 0xffae : Reserved		*/							
	OnlyReti,				/* 0xffb0 : IntDIC			*/	//жԴ:DIC								
	OnlyReti,				/* 0xffb2 : Reserved		*/							
	OnlyReti,				/* 0xffb4 : Reserved		*/									
	OnlyReti,				/* 0xffb6 : Reserved		*/									
	OnlyReti,				/* 0xffb8 : Reserved		*/									
	OnlyReti,				/* 0xffba : Reserved		*/									
	OnlyReti,				/* 0xffbc : Reserved		*/									
	OnlyReti,				/* 0xffbe : Reserved		*/									
	OnlyReti,				/* 0xffc0 : Reserved		*/									
	OnlyReti,				/* 0xffc2 : Reserved		*/									
	OnlyReti,				/* 0xffc4 : IntFMC			*/	//жԴ:Flash								
	OnlyReti,				/* 0xffc6 : Reserved		*/					
	OnlyReti,				/* 0xffc8 : Reserved		*/									
	OnlyReti,				/* 0xffca : Reserved		*/									
	OnlyReti,				/* 0xffcc : Reserved		*/									
	OnlyReti,               /* 0xffce : IntADC			*/	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : IntEXT3			*/	//ⲿж3								
	IntEXT2,				/* 0xffd2 : IntEXT2			*/	//ⲿж2								
	IntEXT1,				/* 0xffd4 : IntEXT1			*/	//ⲿж1								
	IntEXT0,				/* 0xffd6 : IntEXT0			*/	//ⲿж0								
	OnlyReti,				/* 0xffd8 : IntSIO0			*/	//жԴ:SIO 0								
	IntI2C0,				/* 0xffda : IntI2C0			*/	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : IntTX0			*/	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : IntRX0			*/	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		*/									
	OnlyReti,				/* 0xffe2 : Reserved		*/									
	OnlyReti,				/* 0xffe4 : Reserved		*/									
	OnlyReti,				/* 0xffe6 : IntTCA1			*/	//жԴ:TCA1 16λʱ								
	OnlyReti,				/* 0xffe8 : IntTCA0			*/	//жԴ:TCA0 16λʱ								
	OnlyReti,				/* 0xffea : Reserved		*/									
	OnlyReti,				/* 0xffec : Reserved		*/									
	OnlyReti,			    /* 0xffee : IntRTC			*/	//жԴ:ʵʱʱRTCʱ								
	OnlyReti,				/* 0xfff0 : IntTBT			*/  //жԴ:ʱTBTʱ				
	OnlyReti,				/* 0xfff2 : Reserved		*/									
	OnlyReti,				/* 0xfff4 : IntCFD			*/	//жԴ:ʱʧЧ								
	OnlyReti,				/* 0xfff6 : IntLVD			*/	//жԴ:͵ѹLVD							
	IntWDT,					/* 0xfff8 : IntWDT			*/	//non-maskable жԴ:Źʱ		
	(void *)0xffff,			/* 0xfffa : Reserved		*/									
	IntSWI,					/* 0xfffc : IntSWI/INTUNDEF */	//non-maskable		
	STARTUP					/* 0xfffe : RESET			*/	//non-maskable			
};
#pragma section const
/* -------------------  SQ7615ж ---------------------- */

